package com.caimei365.order.service;

import com.alibaba.fastjson.JSONObject;
import com.caimei365.order.model.ResponseJson;
import com.caimei365.order.model.dto.HeliDto;
import com.caimei365.order.model.dto.PayDto;
import com.caimei365.order.model.vo.AccountResVo;
import com.caimei365.order.model.vo.AppCreateOrderVo;
import com.caimei365.order.model.vo.NotifyResponseVo;
import com.caimei365.order.model.vo.UnionResVo;
import org.springframework.http.HttpHeaders;

import javax.servlet.http.HttpServletRequest;
import java.beans.IntrospectionException;
import java.lang.reflect.InvocationTargetException;
import java.security.NoSuchAlgorithmException;
import java.security.spec.InvalidKeySpecException;

/**
 * Description
 *
 * @author : zzj
 * @date : 2021/11/11
 */
public interface HeliPayService {
    ResponseJson<JSONObject> payByWeChat(HeliDto heliDto, HttpHeaders headers);

    ResponseJson<JSONObject> payOnline(HeliDto heliDto, HttpHeaders headers);
    /**
     * 回调
     */
    String paymentCallback(NotifyResponseVo res) throws IntrospectionException, InvocationTargetException, IllegalAccessException;

    ResponseJson<String> link(HeliDto heliDto, HttpHeaders headers);

    /**
     * 延时分账
     */
    void delayedSplitting(String callUrl);
    /**
     * 延时分账异步回调
     */
    String delayedSplittingCallback(AccountResVo data);

    ResponseJson<JSONObject> bankCode();

    ResponseJson<JSONObject> getPayOrderResult(String mbOrderId);
    /**
     * 银联回调
     */
    String unionCallback(UnionResVo res) throws IntrospectionException, InvocationTargetException, IllegalAccessException;

}
